classdef MT5ConfigGenerator
    %MT5CONFIG Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        
        config_default
        config_write
        config_read
        config_modified
        iniFilePath
        
        IniConfig  % handle for Ini File Class
    end
    
    methods
        function obj = MT5ConfigGenerator()
            %MT5CONFIG Construct an instance of this class
            %   Detailed explanation goes here
            obj.IniConfig =  AICore.IniConfig();
            obj.config_default = AICore.MT5Config;
            
        end
        
        function ok = write_Ini(self)
            %METHOD1 Summary of this method goes here
            %   Detailed explanation goes here
            
            props = properties(self.config_default);
            
            for index = 2:length(props)
                 prop = props{index};
                 prop_value = self.config_default.(prop);
                 
                 if prop == "Sections"
                     sections = prop_value;
                     continue;
                 end
                 
                 if strfind(prop,"Section") == 1
                     Section = prop_value;
                     self.IniConfig.AddSections(prop_value);
                     continue;
                 end
                 
                 self.IniConfig.AddKeys(Section,prop,self.config_default.(prop));
                 
                 
%                  fprintf('Propertie: %s    %s  \n',prop,prop_value)
                    
            end
        
            if self.IniConfig.WriteFile(self.iniFilePath)            
             ok = true;
            else
             ok = false;
            end
            
        end
        
        function [ok, opts] = load_defaults_for(self,instance,opts)
            
            switch instance
                
                case 'AA'
                    
                    PreConfig = opts.mt5.Instance.AA.PreConfig;
                    
                    self.config_default.ShutdownTerminal = PreConfig.ShutdownTerminal;
                    self.config_default.Login            = PreConfig.Login;
                    self.config_default.FromDate         = datestr(opts.mt5.FromDate,'yyyy.mm.dd');
                    self.config_default.ToDate           = datestr(opts.mt5.ToDate,'yyyy.mm.dd');
                    
                    
                    ok = true;
                    
                case 'AB'
                    
                   PreConfig = opts.mt5.Instance.AB.PreConfig;
                    
                    self.config_default.ShutdownTerminal = PreConfig.ShutdownTerminal;
                    self.config_default.Login            = PreConfig.Login;
                    self.config_default.Port             = PreConfig.Port;
                    self.config_default.FromDate         = datestr(opts.mt5.FromDate,'yyyy.mm.dd');
                    self.config_default.ToDate           = datestr(opts.mt5.ToDate,'yyyy.mm.dd');
                    
                    
                    ok = true;  
                    
                case 'AC'
                    
                    PreConfig = opts.mt5.Instance.AC.PreConfig;
                    
                    self.config_default.ShutdownTerminal = PreConfig.ShutdownTerminal;
                    self.config_default.Login            = PreConfig.Login;
                    self.config_default.Port             = PreConfig.Port;
                    self.config_default.FromDate         = datestr(opts.mt5.FromDate,'yyyy.mm.dd');
                    self.config_default.ToDate           = datestr(opts.mt5.ToDate,'yyyy.mm.dd');
                    
                    
                    ok = true;  
                    
                case 'AD'
                    
                    PreConfig = opts.mt5.Instance.AD.PreConfig;
                    
                    self.config_default.ShutdownTerminal = PreConfig.ShutdownTerminal;
                    self.config_default.Login            = PreConfig.Login;
                    self.config_default.Port             = PreConfig.Port;
                    self.config_default.FromDate         = datestr(opts.mt5.FromDate,'yyyy.mm.dd');
                    self.config_default.ToDate           = datestr(opts.mt5.ToDate,'yyyy.mm.dd');
                    
                    
                    ok = true; 
                    
                otherwise 
                    error('Wrong Instance Name');
                    ok == false;
            end  
            
        end
        
        function [ok, opts] = generateConfig(self,instance,opts)
            
                 
            ok = true;
            
            switch instance
                
                case 'AA'
        
        
                    self.iniFilePath = strcat(opts.core.path,'\mt5_config.ini');

                    self.write_Ini();

                    opts.mt5.Instance.StartCommand = strcat(opts.mt5.Instance.AA.PathtoTerminal, 'Terminal64_parallel.lnk /config:  ',self.iniFilePath,' &'); 
                    opts.mt5.terminalpath          = strcat(opts.mt5.Instance.AA.PathtoTerminal, 'terminal64.exe');
                    
                case 'AB'
        
        
                    self.iniFilePath = strcat(opts.core.path,'\mt5_config.ini');

                    self.write_Ini();

                    opts.mt5.Instance.StartCommand = strcat(opts.mt5.Instance.AB.PathtoTerminal, 'Terminal64_parallel.lnk /config:  ',self.iniFilePath,' &'); 
                    opts.mt5.terminalpath          = strcat(opts.mt5.Instance.AB.PathtoTerminal, 'terminal64.exe');
                    
                case 'AC'
        
        
                    self.iniFilePath = strcat(opts.core.path,'\mt5_config.ini');

                    self.write_Ini();

                    opts.mt5.Instance.StartCommand = strcat(opts.mt5.Instance.AC.PathtoTerminal, 'Terminal64_parallel.lnk /config:  ',self.iniFilePath,' &');   
                    opts.mt5.terminalpath          = strcat(opts.mt5.Instance.AC.PathtoTerminal, 'terminal64.exe');
                    
                case 'AD'
        
        
                    self.iniFilePath = strcat(opts.core.path,'\mt5_config.ini');

                    self.write_Ini();

                    opts.mt5.Instance.StartCommand = strcat(opts.mt5.Instance.AD.PathtoTerminal, 'Terminal64_parallel.lnk /config:  ',self.iniFilePath,' &');    
                    opts.mt5.terminalpath          = strcat(opts.mt5.Instance.AD.PathtoTerminal, 'terminal64.exe');
                    
                otherwise 
                    error('Wrong Instance Name');
                    ok = false;
            end   
            
        end
        
    end
end

